// SysMem.cpp : Defines the initialization routines for the DLL.
//
// created by Unwinder
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include <float.h>
#include <shlwapi.h>
#include <afxdllx.h>
#include <winbase.h>
 
#include "SysMem.h"
#include "RivaTunerExports.h"
#include "MonitoringSourceDesc.h"
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
static AFX_EXTENSION_MODULE SysMemDLL = { NULL, NULL };
/////////////////////////////////////////////////////////////////////////////
HINSTANCE					g_hModule						= 0;
/////////////////////////////////////////////////////////////////////////////
extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(SysMemDLL, hInstance))
			return 0;

		new CDynLinkLibrary(SysMemDLL);

		g_hModule = hInstance;
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		AfxTermExtensionModule(SysMemDLL);
	}
	return 1;
}
//////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to get a number of
// data sources in this plugin
//////////////////////////////////////////////////////////////////////
SYSMEM_API DWORD GetSourcesNum()
{
	return 2;
}
//////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to get descriptor
// for the specified data source
//////////////////////////////////////////////////////////////////////
SYSMEM_API BOOL GetSourceDesc(DWORD dwIndex, LPMONITORING_SOURCE_DESC pDesc)
{
	//get host application module handle

	HMODULE hHost = GetModuleHandle(NULL);
	if (!hHost)
		return FALSE;

	//we'll use this condition to verify if we're under RivaTuner v2.0 RC 15.7
	//(older versions are not supported) or any other compatible host

	GET_HOST_APP_ID_PROC pGetHostAppID = (GET_HOST_APP_ID_PROC)GetProcAddress(hHost, "GetHostAppID");
	if (!pGetHostAppID)
		return FALSE;

	switch (dwIndex)
	{
	case 0:
		strcpy(pDesc->szName	, "Physical memory usage");
		strcpy(pDesc->szDim		, "MB");

		pDesc->fltMaxLimit	= 4096.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc	, "Physical memory usage reported by GlobalSysMemorystatusEx");

		return TRUE;
	case 1:
		strcpy(pDesc->szName	, "Page file usage");
		strcpy(pDesc->szDim		, "MB");

		pDesc->fltMaxLimit	= 4096.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc	, "Page file usage reported by GlobalSysMemorystatusEx");

		return TRUE;
	}

	return FALSE;
}
/////////////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to poll data sources
/////////////////////////////////////////////////////////////////////////////
SYSMEM_API FLOAT GetSourceData(DWORD dwIndex)
{
	MEMORYSTATUS status; 
	status.dwLength = sizeof(MEMORYSTATUS);

	GlobalMemoryStatus(&status);

	switch (dwIndex)
	{
	case 0:
		return (status.dwTotalPhys - status.dwAvailPhys) / 1048576.0f;
	case 1:
		return (status.dwTotalPageFile - status.dwAvailPageFile) / 1048576.0f;
	}

	return FLT_MAX;
}
/////////////////////////////////////////////////////////////////////////////
