// W83L785R.cpp : Defines the initialization routines for the DLL.
//
// created by Unwinder
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include <float.h>
#include <shlwapi.h>
#include <afxdllx.h>

#include "W83L785R.h"
#include "RivaTunerExports.h"
#include "MonitoringSourceDesc.h"
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
static AFX_EXTENSION_MODULE W83L785RDLL = { NULL, NULL };
/////////////////////////////////////////////////////////////////////////////
GET_DEVICE_ID_PROC			g_pGetDeviceID		= NULL;
GET_I2C_BUS_NUM_PROC		g_pGetI2CBusNum		= NULL;
READ_I2C_PROC				g_pReadI2C			= NULL;

BYTE						g_bus				= 0;
BYTE						g_dev				= 0;

FLOAT						g_fltVoltageRatio0	= 0;
FLOAT						g_fltVoltageRatio1	= 0;
FLOAT						g_fltVoltageRatio2	= 0;
FLOAT						g_fltVoltageRatio3	= 0;

FLOAT						g_fltTemperature0	= FLT_MAX;
FLOAT						g_fltTemperature1	= FLT_MAX;

FLOAT						g_fltFanDutyCycle	= FLT_MAX;
FLOAT						g_fltFanSpeed		= FLT_MAX;

FLOAT						g_fltVoltage0		= FLT_MAX;
FLOAT						g_fltVoltage1		= FLT_MAX;
FLOAT						g_fltVoltage2		= FLT_MAX;
FLOAT						g_fltVoltage3		= FLT_MAX;

HINSTANCE					g_hModule			= 0;
/////////////////////////////////////////////////////////////////////////////
extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(W83L785RDLL, hInstance))
			return 0;

		new CDynLinkLibrary(W83L785RDLL);

		g_hModule = hInstance;
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		AfxTermExtensionModule(W83L785RDLL);
	}
	return 1;
}
/////////////////////////////////////////////////////////////////////////////
// This helper function rips required string param from specified
//<Param0><Separator><Param1><Separator>...<ParamN>-styled string
/////////////////////////////////////////////////////////////////////////////
BOOL GetParam(int iParam, LPCSTR lpSrc, CString &strParam, LPCSTR lpSeparator)
{
	CString strSrc = lpSrc;

	int iFirst = 0;

	while (iParam)
	{
		iFirst = strSrc.Find(lpSeparator, iFirst);

		if (iFirst == -1)
			return FALSE;

		iFirst++;
		iParam--;
	}

	int iLast = strSrc.Find(lpSeparator ,iFirst);

	if (iLast == -1)
		iLast = strlen(lpSrc);

	strParam = strSrc.Mid(iFirst, iLast - iFirst);

	strParam.TrimRight();
	strParam.TrimLeft();

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// This helper function compares two strings using whildcard character
/////////////////////////////////////////////////////////////////////////////
int CompareWithWildcard(LPCSTR str0, LPCSTR str1, char wildcard)
{
	int nLen0	= strlen(str0);
	int nLen1	= strlen(str1);

	if (nLen0 > nLen1)
		return 1;

	if (nLen0 < nLen1)
		return -1;

	for (int i=0; i<nLen0; i++)
	{
		char c0 = str0[i];
		char c1 = str1[i];

		if ((c0 != wildcard) &&
			(c1 != wildcard))
			if (c0 != c1)
				return (c0 > c1) ? 1 : -1;
	}

	return 0;
}
/////////////////////////////////////////////////////////////////////////////
// This helper function reads the first matching entry for the currently
// selected display adapter from the specified section of .cfg
//
// Note: the entries in .cfg can be specified with wildcard character '?'
/////////////////////////////////////////////////////////////////////////////
CString GetMatchingHardwareEntry(LPCSTR lpSection)
{
	char szCfgPath[MAX_PATH];
	GetModuleFileName(g_hModule, szCfgPath, MAX_PATH);
	
	PathRenameExtension(szCfgPath, ".cfg");
		//get fully qualified path to .cfg

	LPSTR	lpBuf		= new char[32768];
		//allocate buffer for section
	if (GetPrivateProfileSection(lpSection, lpBuf, 32768, szCfgPath))
		//try to read section, continue if succeeded
	{
		CString strDeviceID	= g_pGetDeviceID();	
			//get display adapter's PCI DeviceID string

		LPSTR	lpStr	= (LPSTR)lpBuf;
 		int		nLen	= strlen(lpStr);

		CString strLValue, strRValue;

		while (nLen)
			//loop through all section's lines
		{

			if (GetParam(0, lpStr, strLValue, "=") &&
				GetParam(1, lpStr, strRValue, "="))
				//try to rip <LValue>=<RValue>-formatted line and proceed
				//if format is correct
			{
				if (!CompareWithWildcard(strLValue, strDeviceID, '?'))
					//compare LValue with PCI DeviceID string
					//take a note that we'll use wildcards to allow multiple
					//display adapters to be specified with a single .cfg line
				{
					delete [] lpBuf;
						//deallocate buffer we've allocated before

					return strRValue;
				}
			}

			lpStr	+=	nLen + 1;
			nLen	=	strlen(lpStr);
				//proceed with next section's line
		}
	}

	delete [] lpBuf;
		//deallocate buffer we've allocated before

	return "";
		//return empty string if we've failed to find matching hardware entry
}
//////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to get a number of
// data sources in this plugin
//////////////////////////////////////////////////////////////////////
W83L785R_API DWORD GetSourcesNum()
{
	return 8;
}
//////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to get descriptor
// for the specified data source
//////////////////////////////////////////////////////////////////////
W83L785R_API BOOL GetSourceDesc(DWORD dwIndex, LPMONITORING_SOURCE_DESC pDesc)
{
	//get host application module handle

	HMODULE hHost = GetModuleHandle(NULL);
	if (!hHost)
		return FALSE;

	if (!g_dev)
		//small performance optimization: once the sensor is detected, we'll
		//precache its' location and will no longer perform I2C scanning
	{
		//get ptr to host application ID routine and return error if the host doesn't 
		//export it

		//we'll use this condition to verify if we're under RivaTuner v2.0 RC 15.7
		//(older versions are not supported) or any other compatible host

		GET_HOST_APP_ID_PROC pGetHostAppID = (GET_HOST_APP_ID_PROC)GetProcAddress(hHost, "GetHostAppID");
		if (!pGetHostAppID)
			return FALSE;

		//get ptrs to required plugin API functions

		g_pGetDeviceID		= (GET_DEVICE_ID_PROC)GetProcAddress(hHost, "GetDeviceID");
		if (!g_pGetDeviceID)
			return FALSE;

		g_pGetI2CBusNum		= (GET_I2C_BUS_NUM_PROC)GetProcAddress(hHost, "GetI2CBusNum");
		if (!g_pGetI2CBusNum)
			return FALSE;

		g_pReadI2C			= (READ_I2C_PROC)GetProcAddress(hHost, "ReadI2C");
		if (!g_pReadI2C)
			return FALSE;

		//once we've got all function ptrs, we can proceed with I2C bus scanning

		//first, we'll get number of I2C buses for the selected display device

		BYTE busNum		= g_pGetI2CBusNum();
		if (!busNum)
			return FALSE;

		//scan all I2C buses and check W83L785R sensor presence	

		for (BYTE bus=0; bus<busNum; bus++)
		{
			BYTE data;

			if (g_pReadI2C(bus, 0x2D, 0x4C, &data) && (data == 0xA3))
				//check W83L785R vendor ID (low byte)
				if (g_pReadI2C(bus, 0x2D, 0x4D, &data) && (data == 0x5C))
					//check W83L785R vendor ID (high byte)
					if (g_pReadI2C(bus, 0x2D, 0x4E, &data) && (data == 0x60))
						//check W83L785R chip ID
					{
						//we've found W83L785R and can precache its' location

						g_bus = bus;
						g_dev = 0x2D;
						break;
					}
		}

		//once the sensor is detected we should calibrate its' voltage inputs
		//to do it we'll read matching entry for our hardware from the .cfg's
		//[VoltageRatioN] section and rip voltage input ratios from it

		sscanf(GetMatchingHardwareEntry("VoltageRatio0"), "%f", &g_fltVoltageRatio0);
		sscanf(GetMatchingHardwareEntry("VoltageRatio1"), "%f", &g_fltVoltageRatio1);
		sscanf(GetMatchingHardwareEntry("VoltageRatio2"), "%f", &g_fltVoltageRatio2);
		sscanf(GetMatchingHardwareEntry("VoltageRatio3"), "%f", &g_fltVoltageRatio3);
	}

	if (!g_dev)
		//return FALSE if we've not detected W83L785R
		return FALSE;

	CString strSourceName;

	switch (dwIndex)
		//now the sensor's location is detected,
		//so we can return requested information to RivaTuner
	{
	case 0:
		//fill temperature 0 source descriptor

		strSourceName = GetMatchingHardwareEntry("TemperatureName0");
		if (strSourceName.IsEmpty())
			return FALSE;

		strcpy(pDesc->szName	, strSourceName);
		strcpy(pDesc->szDim		, "C");

		pDesc->fltMaxLimit	= 200.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc, " Temperature reported by W83L785R-compatible sensor ");

		return TRUE;

	case 1:
		//fill temperature 1 source descriptor

		strSourceName = GetMatchingHardwareEntry("TemperatureName1");
		if (strSourceName.IsEmpty())
			return FALSE;

		strcpy(pDesc->szName	, strSourceName);
		strcpy(pDesc->szDim		, "C");

		pDesc->fltMaxLimit	= 200.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc, " Temperature reported by W83L785R-compatible sensor ");

		return TRUE;

	case 2:
		//fill fan duty cycle source descriptor

		strcpy(pDesc->szName	, "Fan duty cycle");
		strcpy(pDesc->szDim		, "%");

		pDesc->fltMaxLimit	= 100.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc, " Fan duty cycle reported by W83L785R-compatible sensor ");

		return TRUE;

	case 3:
		if (g_fltVoltageRatio0 != 0.0f)
			//fill voltage 0 source descriptor if voltage input 0 is calibrated properly
		{
			strSourceName = GetMatchingHardwareEntry("VoltageName0");
			if (strSourceName.IsEmpty())
				return FALSE;

			strcpy(pDesc->szName	, strSourceName);
			strcpy(pDesc->szDim		, "V");

			pDesc->fltMaxLimit	= 5.0f;
			pDesc->fltMinLimit	= 0.0f;
			pDesc->fltGridDim	= 10.0f;

			strcpy(pDesc->szDesc, " Voltage reported by W83L785R-compatible sensor ");

			return TRUE;
		}
		break;

	case 4:
		if (g_fltVoltageRatio1 != 0.0f)
			//fill voltage 1 source descriptor if voltage input 1 is calibrated properly
		{
			strSourceName = GetMatchingHardwareEntry("VoltageName1");
			if (strSourceName.IsEmpty())
				return FALSE;

			strcpy(pDesc->szName	, strSourceName);
			strcpy(pDesc->szDim		, "V");

			pDesc->fltMaxLimit	= 5.0f;
			pDesc->fltMinLimit	= 0.0f;
			pDesc->fltGridDim	= 10.0f;

			strcpy(pDesc->szDesc, " Voltage reported by W83L785R-compatible sensor ");

			return TRUE;
		}
		break;

	case 5:
		if (g_fltVoltageRatio2 != 0.0f)
			//fill voltage 2 source descriptor if voltage input 2 is calibrated properly
		{
			strSourceName = GetMatchingHardwareEntry("VoltageName2");
			if (strSourceName.IsEmpty())
				return FALSE;

			strcpy(pDesc->szName	, strSourceName);
			strcpy(pDesc->szDim		, "V");

			pDesc->fltMaxLimit	= 5.0f;
			pDesc->fltMinLimit	= 0.0f;
			pDesc->fltGridDim	= 10.0f;

			strcpy(pDesc->szDesc, " Voltage reported by W83L785R-compatible sensor ");

			return TRUE;
		}
		break;

	case 6:
		if (g_fltVoltageRatio3 != 0.0f)
			//fill voltage 3 source descriptor if voltage input 3 is calibrated properly
		{
			strSourceName = GetMatchingHardwareEntry("VoltageName3");
			if (strSourceName.IsEmpty())
				return FALSE;

			strcpy(pDesc->szName	, strSourceName);
			strcpy(pDesc->szDim		, "V");

			pDesc->fltMaxLimit	= 5.0f;
			pDesc->fltMinLimit	= 0.0f;
			pDesc->fltGridDim	= 10.0f;

			strcpy(pDesc->szDesc, " Voltage reported by W83L785R-compatible sensor ");

			return TRUE;
		}
		break;

	case 7:
		//fill fan speed source descriptor

		strcpy(pDesc->szName	, "Fan speed");
		strcpy(pDesc->szDim		, "RPM");

		pDesc->fltMaxLimit	= 10000.0f;
		pDesc->fltMinLimit	= 0.0f;
		pDesc->fltGridDim	= 10.0f;

		strcpy(pDesc->szDesc, " Fan speed reported by W83L785R-compatible sensor ");

		return TRUE;
	}

	return FALSE;
}
/////////////////////////////////////////////////////////////////////////////
// This exported function is called by RivaTuner to poll data sources
/////////////////////////////////////////////////////////////////////////////
W83L785R_API FLOAT GetSourceData(DWORD dwIndex)
{
	FLOAT	result	= FLT_MAX;	
	BYTE	data;

	switch (dwIndex)
	{
	case 0:
		//temperature 0

		if (g_pReadI2C(g_bus, g_dev, 0x27, &data))
			result = (char)data;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltTemperature0 = result;

		//return last correctly read value

		return g_fltTemperature0;

	case 1:
		//temperature 1

		if (g_pReadI2C(g_bus, g_dev, 0x26, &data))
			result = (char)data;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltTemperature1 = result;

		//return last correctly read value

		return g_fltTemperature1;

	case 2:
		//fan duty cycle

		if (g_pReadI2C(g_bus, g_dev, 0x81, &data))
			result = data * 100.0f / 255.0f;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltFanDutyCycle = result;

		//return last correctly read value

		return g_fltFanDutyCycle;

	case 3:
		//voltage 0

		if (g_pReadI2C(g_bus, g_dev, 0x20, &data))
			result = data * 8.0f * g_fltVoltageRatio0 / 1000.0f;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltVoltage0 = result;

		//return last correctly read value

		return g_fltVoltage0;

	case 4:
		//voltage 1

		if (g_pReadI2C(g_bus, g_dev, 0x21, &data))
			result = data * 8.0f * g_fltVoltageRatio1 / 1000.0f;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltVoltage1 = result;

		//return last correctly read value

		return g_fltVoltage1;

	case 5:
		//voltage 2

		if (g_pReadI2C(g_bus, g_dev, 0x22, &data))
			result = data * 8.0f * g_fltVoltageRatio2 / 1000.0f;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltVoltage2 = result;

		//return last correctly read value

		return g_fltVoltage2;

	case 6:
		//voltage 3

		if (g_pReadI2C(g_bus, g_dev, 0x23, &data))
			result = data * 8.0f * g_fltVoltageRatio3 / 1000.0f;

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltVoltage3 = result;

		//return last correctly read value

		return g_fltVoltage3;

	case 7:
		//fan speed

		if (g_pReadI2C(g_bus, g_dev, 0x47, &data))
		{
			BYTE divisor = 1<<(data & 3);

			if (g_pReadI2C(g_bus, g_dev, 0x28, &data))
			{
				BYTE count = data;

				if (count)
					result = 1350000.0f / (count * divisor);
			}
		}

		//perform misreading filtering

		if (result != FLT_MAX)
			g_fltFanSpeed = result;

		//return last correctly read value

		return g_fltFanSpeed;
	}

	return result;
}
/////////////////////////////////////////////////////////////////////////////
